<?php
/* 
Steam2Friends vBulletin plugin by KoST & 8088
http://forums.alliedmods.net/showthread.php?t=60899

Edit the paths in line 58 and 62 accordingly. Note that these paths should be absolute, not relative.
To enable memcached, uncomment the commented blocks below (lines 22-31 and 86-89) and replace <port> with the portnumber on which memcached is listening. The default is 11211.
*/
function steam2friend($steam_id){
	$steam_id=strtolower($steam_id);
	if (substr($steam_id,0,7)=='steam_0') {
		$tmp=explode(':',$steam_id);
		if ((count($tmp)==3) && is_numeric($tmp[1]) && is_numeric($tmp[2])){
			return bcadd((($tmp[2]*2)+$tmp[1]),'76561197960265728');
		}else return false;
	}else{
		return false;
	}
}
function get_steam_stats($id){
//uncomment the following block to enable memcached support
/*
	$mc=new Memcache;
	if (!@$mc->connect('localhost', <port>)) {
		echo 'Houston, we have a problem - the player\'s status cannot be retrieved.';
		return false;
	}

	$ret=@$mc->get('xd'.$id);
	if (!$ret){
*/
		$data=file_get_contents('http://steamcommunity.com/profiles/'.$id);
		$ret=array();
		$ret['uid']=intval($_GET['u']);
		if (strpos($data,'<h2>Private Profile</h2>')!==false) {
			$ret['private']=1;
		}else{
			if (strpos($data,'status_online.gif')!==false){
				$ret['online']=1;
			}else if (($p1=strpos($data,'<p id="statusInGameText">'))!==false){
				$p2=strpos($data,'<',$p1+25);
				$tmp=substr($data,$p1+25,$p2-$p1-25);
				$ret['ingame']=$tmp;
				$ret['join']='steam://friends/joingame/'.$id;
			}else{
				if (($p1=strpos($data,'<p id="statusOfflineText">'))!==false){
					$p2=strpos($data,'<',$p1+26);
					$tmp=substr($data,$p1+26,$p2-$p1-26);
					$ret['offline']=$tmp;
				}
			}
			if (($p1=strpos($data,'<div class="avatarFull">'))!==false){
				$p1=strpos($data,'<',$p1+24);
				$p2=strpos($data,'>',$p1+1);
				$tmp=substr($data,$p1,$p2-$p1+1);
				$link_full=get_link_src($tmp);
				gaben_downloadz0r($link_full,'/absolute/path/to/forum/steamtools/icons/avatar_full'.$ret['uid'].'.jpg');
				$ret['img_full']=$tmp;
				$tmp=str_replace('_full','',$tmp);
				$link_small=get_link_src($tmp);
				gaben_downloadz0r($link_small,'/absolute/path/to/forum/steamtools/icons/avatar_small'.$ret['uid'].'.jpg');
				$ret['img_small']=$tmp;
			}
			if (($p1=strpos($data,'Steam Rating:</div>'))!==false){
				$p2=strpos($data,'<',$p1+19);
				$tmp=substr($data,$p1+19,$p2-$p1-19);
				$ret['rating']=trim($tmp);
			}
			if (($p1=strpos($data,'<h1>'))!==false){
				$p2=strpos($data,'<',$p1+4);
				$tmp=substr($data,$p1+4,$p2-$p1-4);
				$ret['steamname']=trim($tmp);
			}
			if (($p1=strpos($data,'Member since:</div>'))!==false){
				$p2=strpos($data,'<',$p1+19);
				$tmp=substr($data,$p1+19,$p2-$p1-19);
				$ret['member']=trim($tmp);
			}
			if (($p1=strpos($data,'Playing time:</div>'))!==false){
				$p2=strpos($data,'<',$p1+19);
				$tmp=substr($data,$p1+19,$p2-$p1-19);
				$ret['time']=trim($tmp);
			}
		}
//uncomment the following block to enable memcached support
/*
		@$mc->set('xd'.$id,$ret,MEMCACHE_COMPRESSED,300);
	}
*/
	return $ret;
}
function get_link_src($data){
	$p1=strpos($data,chr(34));
	$p2=strpos($data,chr(34),$p1+1);
	return substr($data,$p1+1,$p2-$p1-1);
}
function gaben_downloadz0r ($url,$target){
	$data=file_get_contents($url);
	if ($data) {
		file_put_contents($target,$data);
	}
}
?>